import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Gator in my game that can eat turtles.
 * 
 * @author MasterElectro01
 * @version 2.0
 */
public class Gator extends Animal
{
   
    public void act()
    {
        // vhfj vhfdkvbhd vbhdfj
        move(4);
        randomTurn();
        turnAtEdge();
        tryToEat();
    }
    
    /**
     * With a 10% probability, turn a bit right or left.
     */
    public void randomTurn()
    {
        if ( Greenfoot.getRandomNumber(100) < 10 )
        {
            turn( Greenfoot.getRandomNumber(40)-20 );
        }        
    }
    
    /**
     * If we reach the edge of the world, turn a little bit.
     */
    public void turnAtEdge()
    {
        if (atWorldEdge())
        {
            turn(7);
        }
    }
    
    /**
     * Check whether we can see anything. If we can, eat it.
     */
    public void tryToEat()
    {
        if (canSee(Grass.class) )
        {
            eat(Grass.class);
            createNewGrass();
        }
        
        if (canSee(Snake.class) )
        {
            eat(Snake.class);
            createNewSnake();
        }
        
        if (canSee(Leaf.class) )
        {
            eat(Leaf.class);
            createNewLeaf();
        }
        
        if (canSee(Bug.class) )
        {
            eat(Bug.class);
            createNewBug();
        }
        
        if (canSee(Turtle.class) )
        {
            eat(Turtle.class);
            Greenfoot.playSound("game-over.wav");
            Greenfoot.stop();
        }
    }

    /**
     * Create a new bug and insert it at a random location in the world.
     */
    private void createNewBug()
    {
        Bug newBug;
        newBug = new Bug();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newBug, x, y);
    }
    
    /**
     * Create a new snake and insert it at a random location in the world.
     */
    private void createNewSnake()
    {
        Snake newSnake;
        newSnake = new Snake();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newSnake, x, y);
    }
    
    
    /**
     * Create a new leaf and insert it at a random location in the world.
     */
    private void createNewLeaf()
    {
        Leaf newLeaf;
        newLeaf = new Leaf();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newLeaf, x, y);
    }
        
    /**
     * Create a new Grass and insert it at a random location in the world.
     */
    private void createNewGrass()
    {
        Grass newGrass;
        newGrass = new Grass();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newGrass, x, y);
    }
}
