import greenfoot.*; 

/**
 * Write a description of class Bug here.
 * 
 * @author (MasterElectro01) 
 * @version (2.0)
 */
public class Turtle2 extends Animal
{
    private Counter2 counter22;
    
    public Turtle2(Counter2 pointCounter2)
    {
        counter22 = pointCounter2;
    }
    
    public void act()
    {
        checkKeys();
        tryToEat();
    }

    /**
     * Check whether the control keys are being pressed, and turn
     * if they are.
     */
    public void checkKeys()
    {
        if ( Greenfoot.isKeyDown("a") )
        {
            turn(-5);
        }
        
        if ( Greenfoot.isKeyDown("d") )
        {
            turn(5);
        }
        
        if ( Greenfoot.isKeyDown("s") )
        {
            move(-5);
        }
        
        if ( Greenfoot.isKeyDown("w") )
        {
            move(5);
        }
    }

    /**
     * Check whether we can see grass, bugs, or leaves. If we can, eat it.
     */
    public void tryToEat()
    {
        if (canSee(Grass.class) )
        {
            eat(Grass.class);
            counter22.add(2);
            Greenfoot.playSound("slurp.wav");
            createNewGrass();
        }
        
        if (canSee(Leaf.class) )
        {
            eat(Leaf.class);
            counter22.add(2);
            Greenfoot.playSound("slurp.wav");
            createNewLeaf();
        }
        
        if (canSee(Bug.class) )
        {
            eat(Bug.class);
            counter22.add(5);
            Greenfoot.playSound("slurp.wav");
            createNewBug();
        }
        
        if (counter22.getValue() >= 50) {
            gameOver();
        }
    }

    /**
     * Create a new bug and insert it at a random location in the world.
     */
    private void createNewBug()
    {
        Bug newBug;
        newBug = new Bug();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newBug, x, y);
    }
    
    /**
     * Create a new leaf and insert it at a random location in the world.
     */
    private void createNewLeaf()
    {
        Leaf newLeaf;
        newLeaf = new Leaf();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newLeaf, x, y);
    }
        
    /**
     * Create a new grass and insert it at a random location in the world.
     */
    private void createNewGrass()
    {
        Grass newGrass;
        newGrass = new Grass();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newGrass, x, y);
    }
    
    /**
     * We have won the game.
     */
    public void gameOver()
    {
        Greenfoot.playSound("fanfare.wav");
        Greenfoot.stop();
    }
}
